/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 0.91B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "pv.h"
#include "abimport.h"
#include "proto.h"

int filemenu_build( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
	PtArg_t			args[7];
	PtCallback_t	cb;
	int				cnt;
	char			buff[ PATH_MAX + 1];

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	for( cnt = 1; cnt < 4; cnt++ ) {
		if( file_list[cnt][0] != '\0' ) {
			cb.data = (void *)cnt;
			cb.event_f = filename_cb;

			sprintf( buff, "%d", cnt );
			PtSetArg( &args[0], Pt_CB_ACTIVATE, &cb, 0 );
			PtSetArg( &args[1], Pt_ARG_ACCEL_KEY, buff, 0 );
			strcat( buff, ")  " );
			strcat( buff, &file_list[cnt][0] );
			PtSetArg( &args[2], Pt_ARG_FLAGS, Pt_SELECTABLE, Pt_SELECTABLE );
   			PtSetArg( &args[3], Pt_ARG_TEXT_STRING, buff, 0 );
			PtCreateWidget( PtMenuButton, NULL, 4, args );
		}
	}

	if( file_list[1][0] != '\0' ) {
		/* separator */
		PtSetArg( &args[0], Pt_ARG_SEP_TYPE, Pt_ETCHED_IN, 0 );
		PtCreateWidget( PtSeparator, NULL, 1, args ); 
	}

	return( Pt_CONTINUE );
}

int filename_cb( PtWidget_t *widget, void *data, PtCallbackInfo_t *cbinfo )
{
	int		cnt = (int)data;

	/* eliminate 'unreferenced' warnings */
	widget = widget, data = data, cbinfo = cbinfo;

	strcpy( file_name, &file_list[cnt][0] );
	PtAppAddWorkProc( NULL, load_image, 0 );

	return( Pt_CONTINUE );
}

