/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 0.90B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "pv.h"
#include "abimport.h"
#include "proto.h"

int
filemenuitem_cb( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{
	PtArg_t		args[2];
	PhDim_t		dim;
	int			widget_name;

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	widget_name = ApName( widget );

	if( widget_name == ABN_SaveMenuItem ) {
		return( Pt_CONTINUE );
	}
	else if( widget_name == ABN_SaveAsMenuItem ) {
		return( Pt_CONTINUE );
	}

	pimage = NULL;

	if( widget_name == ABN_CloseMenuItem ) {
		dim.w = 300;
		dim.h = 225;

		/* free old image before starting */
		if( pimage ) {
			if( pimage->palette )
				memory_free( pimage->palette, PX_PALETTE );
			if( pimage->image )
				memory_free( pimage->image, PX_IMAGE );
		}
		pimage = NULL;

		PtSetArg( &args[0], Pt_ARG_DIM, &dim, 0 );
		PtSetResources( ABW_base, 1, &args );
		PtDamageWidget( RAW_image );
	}
	else if( widget_name == ABN_ExitMenuItem ) {
		SetPalette( 0 );
		exit( 0 );
	}

	return( Pt_CONTINUE );
}

