/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 0.98B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "pv.h"
#include "abimport.h"
#include "proto.h"

int menu_open_cb( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	SetPalette( 0 );

	return( Pt_CONTINUE );
}

int menu_realized_cb( PtWidget_t *widget, ApInfo_t *apinfo, PtCallbackInfo_t *cbinfo )
{

	/* eliminate 'unreferenced' warnings */
	widget = widget, apinfo = apinfo, cbinfo = cbinfo;

	AddCallback( ApGetWidgetPtr( widget, ABN_OpenMenuItem ), Pt_CB_ACTIVATE, menu_open_cb, NULL );
	return( Pt_CONTINUE );

}

int 
AddCallback( 
	PtWidget_t *widget,
	unsigned long cb_type,
	void (*func)(PtWidget_t *, void *, PtCallbackInfo_t *),
	void *data )
{
	PtArg_t arg;
	PtCallback_t cb;

	if(!widget) return -1;

	cb.event_f = func;
	cb.data = data;
	PtSetArg( &arg, cb_type, &cb, Pt_LINK_INSERT );
	PtSetResources( widget, 1, &arg );
	return 0;
}
