/* Y o u r   D e s c r i p t i o n                       */
/*                            AppBuilder Photon Code Lib */
/*                                         Version 0.90B */

/* Standard headers */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>

/* Toolkit headers */
#include <Ph.h>
#include <Pt.h>
#include <Ap.h>

/* Local headers */
#include "pv.h"
#include "abimport.h"
#include "proto.h"

#define PX_IMAGE_MODULES
#define PX_GIF_SUPPORT
#define PX_JPG_SUPPORT
#define PX_PCX_SUPPORT
#define PX_BMP_SUPPORT
#define PX_TGA_SUPPORT
#define PX_PNG_SUPPORT
#define PX_TIFF_SUPPORT

#include <photon/PxImage.h>
//#include "/src/photon/include/photon/PxImage.h"

extern unsigned long palette[];

void shutdown( int sig );

char	*fname			= NULL;
int		UseShmem		= 1;
int		PaletteType		= Pg_PALSET_SOFT;
int		PaletteBoundary	= 0;
char	file_list[4][PATH_MAX + 1];
char	file_list_cnt	= 0;
int		sindx			= -1;
int		cindx			= -1;
int		lindx			= -1;
char	**cargv;
PtWidget_t *RAW_image;
int		has_focus = 1;
int get_palette = 0;
int pv_quantize = 0;

int timing, switch_time;

void ShuffleArgs()
  {
int n, i, files;
unsigned char *tptr;
		files = (lindx - sindx);
		for (i = sindx; i < lindx; i++)
		  {
			tptr = cargv[i];
			n = i+(rand()%files--);
			cargv[i] = cargv[n];
			cargv[n] = tptr;
		  }
  }

int
pv_init( int argc, char *argv[] )
{
	unsigned char *pname = "/usr/photon/palette/default.pal";
	FILE *fp;
	int opt, get_fpal;

	signal( SIGTERM, shutdown );
	signal( SIGHUP, shutdown );
	signal( SIGQUIT, shutdown );
	signal( SIGINT, shutdown );
 	signal( SIGSEGV, shutdown );

	memset( file_name, 0, sizeof( file_name ) );
	memset( file_list, 0, sizeof( file_list ) );

#if 0
	/* Retreive palette */
	PgGetPalette(palette);

	if (palette[0] == -1)
	  {
		/* True color */
		pv_quantize = 0;
	  }
	else
	  {
		/* Palette based driver */
		pv_quantize = 1;
	  }
	get_fpal = 0;
#else
	/* Force load of /usr.../default.pal */
	get_fpal = 1;
#endif

	while( ( opt = getopt( argc, argv, "t:p:s:x:y:w:h::BHSGQ" ) ) != -1 ) {
		switch( opt ) {

			case 'S':
				UseShmem = 0;
				break;

			case 'P':
				PaletteType = Pg_PALSET_GLOBAL | Pg_PALSET_FORCE_EXPOSE;
				break;

			case 'H':
				PaletteType = Pg_PALSET_HARDINACTIVE;
				break;

			case 'B':
				PaletteBoundary = 1;
				break;

			case 'p':
				get_fpal = 1;
				pname = optarg;
				break;

			case 'G':
				get_palette = 1;
				break;

			case 'Q':
				pv_quantize = 1;
				break;

			case 't':
				timing = 1;
				switch_time = strtol(optarg, NULL, 0);
				break;

			default:
				break;
		}
	}


	if (get_fpal)
	  {
		fp = fopen(pname, "r");
		if (fp)
		  {
			fread(palette, 256, 4, fp);
			fclose(fp);
		  }
	  }

	if( optind != argc ) {
		sindx = cindx = optind;
		lindx = argc - 1;
		cargv = argv;

		ShuffleArgs();

		_fstrcpy( file_name, argv[optind] );
	}

	return( Pt_CONTINUE );
}

void shutdown( int sig )
{
	sig = sig;
	if (sig == SIGSEGV)
	  {
		printf("pv File: %s\n", file_name);
		exit( 0 );
	  }
	SetPalette( 0 );
	PgShmemCleanup( );
	exit( 0 );
}
